Index: oscam-cache.c
===================================================================
--- oscam-cache.c	(revision 11581)
+++ oscam-cache.c	(working copy)
@@ -40,6 +40,7 @@
 	uint8_t             localcards;          // updated if answer from local cards (or proxy using localcards option)
 	uint8_t             proxy;               // updated if answer from local reader
 	uint32_t            count;               // count of same cws receved
+	uint8_t				localgenerated;      // flag for local generated CWs
 	// for push out
 	pthread_rwlock_t    pushout_client_lock;
 	struct s_pushclient *pushout_client;     // list of clients that pushing cw
@@ -59,11 +60,45 @@
 	node                ll_node;             // node for linked list
 } ECMHASH;
 
+typedef struct cw_cache_t
+{
+	uint8_t             cw[16];
+	uint16_t            caid;
+	uint32_t            prid;
+	uint16_t            srvid;
+	struct timeb        first_recv_time;     // time of first cw received
+	struct timeb        upd_time;            // updated time. Update time at each cw got
+	node				ht_node;
+	node				ll_node;
+} CW_CACHE;
+
+typedef struct cw_cache_setting_t
+{
+	int8_t			mode;
+	uint16_t		timediff_old_cw;
+} CW_CACHE_SETTING;
+
 static pthread_rwlock_t cache_lock;
+static pthread_rwlock_t cw_cache_lock;
 static hash_table ht_cache;
+static hash_table ht_cw_cache;
 static list ll_cache;
+static list ll_cw_cache;
 static int8_t cache_init_done = 0;
+static int8_t cw_cache_init_done = 0;
 
+void init_cw_cache(void)
+{
+	if(cfg.cw_cache_size > 0 || cfg.cw_cache_memory > 0)
+	{
+		init_hash_table(&ht_cw_cache, &ll_cw_cache);
+		if (pthread_rwlock_init(&cw_cache_lock,NULL) != 0)
+			{ cs_log("Error creating lock cw_cache_lock!"); }
+		else
+			{ cw_cache_init_done = 1; }
+	}
+}
+
 void init_cache(void)
 {
 	init_hash_table(&ht_cache, &ll_cache);
@@ -76,9 +111,14 @@
 void free_cache(void)
 {
 	cleanup_cache(true);
+	cw_cache_cleanup(true);
+	ecm_cache_cleanup(true);
 	cache_init_done = 0;
+	cw_cache_init_done = 0;
 	deinitialize_hash_table(&ht_cache);
+	deinitialize_hash_table(&ht_cw_cache);
 	pthread_rwlock_destroy(&cache_lock);
+	pthread_rwlock_destroy(&cw_cache_lock);
 }
 
 uint32_t cache_size(void)
@@ -95,6 +135,12 @@
 	return (a->count > b->count) ? -1 : 1; // DESC order by count
 }
 
+static uint8_t time_sort(CW_CACHE *a, CW_CACHE *b)
+{
+	if (((int64_t)(a->upd_time.time) * 1000ull + (int64_t) a->upd_time.millitm) == ((int64_t)(b->upd_time.time) * 1000ull + (int64_t) b->upd_time.millitm)) return 0;
+	return (((int64_t)(a->upd_time.time) * 1000ull + (int64_t) a->upd_time.millitm) > ((int64_t)(b->upd_time.time) * 1000ull + (int64_t) b->upd_time.millitm)) ? -1 : 1;
+}
+
 uint8_t check_is_pushed(void *cwp, struct s_client *cl)
 {
 	struct s_pushclient *cl_tmp;
@@ -161,7 +207,7 @@
 	return NULL;
 }
 
-static int compare_csp_hash(const void *arg, const void *obj)
+int compare_csp_hash(const void *arg, const void *obj)
 {
 	uint32_t h = ((const ECMHASH*)obj)->csp_hash;
 	return memcmp(arg, &h, 4);
@@ -172,6 +218,11 @@
 	return memcmp(arg, ((const CW*)obj)->cw, 16);
 }
 
+static int compare_cw_cache(const void *arg, const void *obj)
+{
+	return memcmp(arg, ((const CW_CACHE*)obj)->cw, 16);
+}
+
 static bool cwcycle_check_cache(struct s_client *cl, ECM_REQUEST *er, CW *cw)
 {
 	(void)cl; (void)er; (void)cw;
@@ -237,7 +288,7 @@
 		if((!cw->proxy && !cw->localcards) // cw received from ONLY cacheex/csp peers
 			&& check_cw.counter>1
 			&& cw->count < check_cw.counter
-			&& (check_cw.mode || !er->cacheex_wait_time_expired))
+			&& (check_cw.mode == 1 || !er->cacheex_wait_time_expired))
 		{
 			goto out_err;
 		}
@@ -256,6 +307,7 @@
 			ecm->cwc_cycletime = cw->cwc_cycletime;
 			ecm->cwc_next_cw_cycle = cw->cwc_next_cw_cycle;
 			ecm->cacheex_src = cw->cacheex_src;
+			ecm->localgenerated = (cw->localgenerated) ? 1:0;
 			ecm->cw_count = cw->count;
 		}
 	}
@@ -265,6 +317,11 @@
 	return ecm;
 }
 
+uint16_t get_cacheex_nopushafter(ECM_REQUEST *er)
+{
+	return caidvaluetab_get_value(&cfg.cacheex_nopushafter_tab, er->caid, 0);
+}
+
 static void cacheex_cache_add(ECM_REQUEST *er, ECMHASH *result, CW *cw, bool add_new_cw)
 {
 	(void)er; (void)result; (void)cw; (void)add_new_cw;
@@ -282,7 +339,7 @@
 		return;
 	}
 
-	debug_ecm(D_CACHEEX|D_CSP, "got pushed ECM %s from %s", buf, er->from_csp ? "csp" : username(er->cacheex_src));
+	debug_ecm(D_CACHEEX|D_CSP, "got pushed ECM %s from %s - hop %i", buf, er->from_csp ? "csp" : username(er->cacheex_src), ll_count(er->csp_lastnodes));
 	CW *cw_first = get_first_cw(result, er);
 	if(!cw_first)
 		return;
@@ -317,9 +374,160 @@
 #endif
 }
 
+CW_CACHE_SETTING get_cw_cache(ECM_REQUEST *er)
+{
+	int32_t i, timediff_old_cw = 0;
+	int8_t mode = 0;
+
+	for(i = 0; i < cfg.cw_cache_settings.cwchecknum; i++)
+	{
+		CWCHECKTAB_DATA *d = &cfg.cw_cache_settings.cwcheckdata[i];
+
+		if(i == 0 && d->caid <= 0)
+		{
+			mode = d->mode;
+			timediff_old_cw = d->counter;
+			continue; //check other, only valid for unset
+		}
+
+		if(d->caid == er->caid || d->caid == er->caid >> 8 || ((d->cmask >= 0 && (er->caid & d->cmask) == d->caid) || d->caid == -1))
+		{
+			if((d->prid >= 0 && d->prid == (int32_t)er->prid) || d->prid == -1)
+			{
+				if((d->srvid >= 0 && d->srvid == er->srvid) || d->srvid == -1)
+				{
+					mode = d->mode;
+					timediff_old_cw = d->counter;
+					break;
+				}
+			}
+		}
+	}
+
+	//check for correct values
+	if(mode>3 || mode<0) mode=0;
+	if(timediff_old_cw<1) timediff_old_cw=0;
+	
+	CW_CACHE_SETTING cw_cache_setting;
+	memset(&cw_cache_setting, 0, sizeof(CW_CACHE_SETTING));
+	cw_cache_setting.mode = mode;
+	cw_cache_setting.timediff_old_cw = timediff_old_cw;
+
+	return cw_cache_setting;
+}
+
+static bool cw_cache_check(ECM_REQUEST *er)
+{
+	if(cw_cache_init_done)
+	{
+		CW_CACHE_SETTING cw_cache_setting = get_cw_cache(er);
+		if(cw_cache_setting.mode > 0)
+		{
+			CW_CACHE *cw_cache = NULL;
+			SAFE_RWLOCK_WRLOCK(&cw_cache_lock);
+			cw_cache = find_hash_table(&ht_cw_cache, &er->cw, sizeof(er->cw), &compare_cw_cache);
+			// add cw to ht_cw_cache if < cw_cache_size
+			if(!cw_cache)
+			{
+				// cw_cache-size(count/memory) pre-check
+				if(
+					(cfg.cw_cache_size && (cfg.cw_cache_size > tommy_hashlin_count(&ht_cw_cache)))
+					|| 	(cfg.cw_cache_memory && (cfg.cw_cache_memory*1024*1024 > (2 * tommy_hashlin_memory_usage(&ht_cw_cache))))
+				)
+				{
+					if(cs_malloc(&cw_cache, sizeof(CW_CACHE)))
+					{
+						memcpy(cw_cache->cw, er->cw, sizeof(er->cw));
+						cw_cache->caid = er->caid;
+						cw_cache->prid = er->prid;
+						cw_cache->srvid = er->srvid;
+						cs_ftime(&cw_cache->first_recv_time);
+						cs_ftime(&cw_cache->upd_time);
+						
+						tommy_hashlin_insert(&ht_cw_cache, &cw_cache->ht_node, cw_cache, tommy_hash_u32(0, &er->cw, sizeof(er->cw)));
+						tommy_list_insert_tail(&ll_cw_cache, &cw_cache->ll_node, cw_cache);
+						
+						SAFE_RWLOCK_UNLOCK(&cw_cache_lock);
+						return true;
+					}
+					else
+					{
+						SAFE_RWLOCK_UNLOCK(&cw_cache_lock);
+						cs_log("[cw_cache] ERROR: NO added HASH to cw_cache!!");
+						return false;
+					}
+				}
+				else
+				{
+					// clean cache call;
+					SAFE_RWLOCK_UNLOCK(&cw_cache_lock);
+					cw_cache_cleanup(false);
+					return false;
+				}
+			}
+			// cw found
+			else
+			{
+				char cw1[16*3+2];
+				char cw2[16*3+2];
+				int8_t drop_cw = 0;
+				int64_t gone_diff = 0;
+
+				gone_diff = comp_timeb(&er->tps, &cw_cache->first_recv_time);
+
+				if(D_CW_CACHE & cs_dblevel)
+				{
+					cs_hexdump(0, cw_cache->cw, 16, cw1, sizeof(cw1));
+					cs_hexdump(0, er->cw, 16, cw2, sizeof(cw2));
+				}
+
+				if(cw_cache_setting.timediff_old_cw > 0 && gone_diff > cw_cache_setting.timediff_old_cw) // late (>cw_cache_setting.timediff_old_cw) cw incoming
+				{
+					if(cw_cache->srvid == er->srvid && cw_cache->caid == er->caid) // & same cw for same caid&srvid
+					{
+						cs_ftime(&cw_cache->upd_time);
+						cs_log_dbg(D_CW_CACHE,"[cw_cache][late CW] cache: %04X:%06X:%04X:%s | in: %04X:%06X:%04X:%s | diff(now): %"PRIi64"ms > %"PRIu16" - %s", cw_cache->caid, cw_cache->prid, cw_cache->srvid, cw1, er->caid, er->prid, er->srvid, cw2, gone_diff, cw_cache_setting.timediff_old_cw, (er->selected_reader && strlen(er->selected_reader->label)) ? er->selected_reader->label : username(er->cacheex_src));
+						drop_cw=1;
+
+					}
+					else if(cw_cache->srvid != er->srvid) // same cw for different srvid & late
+					{
+						cs_ftime(&cw_cache->upd_time);
+						cs_log_dbg(D_CW_CACHE,"[cw_cache][dupe&late CW] cache: %04X:%06X:%04X:%s | in: %04X:%06X:%04X:%s | diff(now): %"PRIi64"ms - %s", cw_cache->caid, cw_cache->prid, cw_cache->srvid, cw1, er->caid, er->prid, er->srvid, cw2, gone_diff, (er->selected_reader && strlen(er->selected_reader->label)) ? er->selected_reader->label : username(er->cacheex_src));
+						drop_cw = 1;
+					}
+
+					if(cw_cache_setting.mode > 1 && drop_cw)
+					{
+						// cw_cache->drop_count++;
+						cs_log_dbg(D_CW_CACHE,"[cw_cache] incoming CW dropped - current cw_cache_size: %i - cw_cache-mem-size: %iMiB", count_hash_table(&ht_cw_cache), 2*(int)tommy_hashlin_memory_usage(&ht_cw_cache)/1024/1024);
+						SAFE_RWLOCK_UNLOCK(&cw_cache_lock);
+						return false;
+					}
+				}
+			}
+			
+			SAFE_RWLOCK_UNLOCK(&cw_cache_lock);
+			return true;
+		}
+	}
+	else
+	{
+		cs_log_dbg(D_CW_CACHE,"[cw_cache] cw_cache_init_done %i cfg.cw_cache_size: %u cfg.cw_cache_memory %u", cw_cache_init_done, cfg.cw_cache_size, cfg.cw_cache_memory);
+		return true;
+	}
+	return true;
+}
+
 void add_cache(ECM_REQUEST *er)
 {
 	if(!cache_init_done || !er->csp_hash) return;
+	
+	// cw_cache_check
+	if(!cw_cache_check(er))
+	{
+		return;
+	}
 
 	ECMHASH *result = NULL;
 	CW *cw = NULL;
@@ -329,15 +537,17 @@
 
 	// add csp_hash to cache
 	result = find_hash_table(&ht_cache, &er->csp_hash, sizeof(uint32_t), &compare_csp_hash);
-	if(!result){
-		if(cs_malloc(&result, sizeof(ECMHASH))){
+	if(!result)
+	{
+		if(cs_malloc(&result, sizeof(ECMHASH)))
+		{
 			result->csp_hash = er->csp_hash;
 			init_hash_table(&result->ht_cw, &result->ll_cw);
 			cs_ftime(&result->first_recv_time);
-
 			add_hash_table(&ht_cache, &result->ht_node, &ll_cache, &result->ll_node, result, &result->csp_hash, sizeof(uint32_t));
-
-		}else{
+		}
+		else
+		{
 			SAFE_RWLOCK_UNLOCK(&cache_lock);
 			cs_log("ERROR: NO added HASH to cache!!");
 			return;
@@ -406,19 +616,123 @@
 		else cw->proxy = 1;
 	}
 
+#ifdef CS_CACHEEX
+	// copy flag for local generated CW
+	if(er->localgenerated || (er->selected_reader && !is_network_reader(er->selected_reader)))
+	{
+		cw->localgenerated = 1;
+		er->localgenerated = 1;
+		// to favorite CWs with this flag while sorting
+		if(cw->count < 0x0F000000)
+			cw->count |= 0x0F000000;
+	}
+	else
+	{
+		cw->localgenerated = 0;
+	}
+#endif
+
 	// always update group and counter
 	cw->grp |= er->grp;
 	cw->count++;
 
+	// add count to er for checking @ cacheex_push
+	er->cw_count += cw->count;
 	// sort cw_list by counter (DESC order)
 	if(cw->count>1)
 		sort_list(&result->ll_cw, count_sort);
 
+#ifdef CS_CACHEEX
+	// dont push not flagged CWs - global
+	if(!er->localgenerated && 
+		(
+			!chk_srvid_localgenerated_only_exception(er)
+			&& (cfg.cacheex_localgenerated_only || chk_ctab_ex(er->caid, &cfg.cacheex_localgenerated_only_caidtab))
+		)
+	)
+	{
+		cs_log_dbg(D_CACHEEX, "cacheex: push denied, cacheex_localgenerated_only->global");
+		SAFE_RWLOCK_UNLOCK(&cache_lock);
+		return;
+	}
+
+	// dont push CW if time for caid > x  && from local reader | proxy
+	if(er->rc < 3 && er->ecm_time && get_cacheex_nopushafter(er) != 0 &&(get_cacheex_nopushafter(er) < er->ecm_time ))
+	{
+		cs_log_dbg(D_CACHEEX, "cacheex: push denied, cacheex_nopushafter %04X:%u < %i, reader: %s", er->caid, get_cacheex_nopushafter(er), er->ecm_time, er->selected_reader->label);
+		SAFE_RWLOCK_UNLOCK(&cache_lock);
+		return;
+	}
+
+	// no cacheex-push on diff-cw's if no localgenerated flag exist
+	if(cfg.cacheex_dropdiffs && (count_hash_table(&result->ht_cw) > 1) && !er->localgenerated)
+	{
+		cs_log_dbg(D_CACHEEX,"cacheex: diff CW - cacheex push denied src: %s", er->selected_reader->label);
+		SAFE_RWLOCK_UNLOCK(&cache_lock);
+		return;
+	}
+#endif
+
 	SAFE_RWLOCK_UNLOCK(&cache_lock);
 
 	cacheex_cache_add(er, result, cw, add_new_cw);
 }
 
+void cw_cache_cleanup(bool force)
+{
+	if(!cw_cache_init_done)
+		{ return; }
+
+	SAFE_RWLOCK_WRLOCK(&cw_cache_lock);
+
+	CW_CACHE *cw_cache;
+	node *i, *i_next;
+		
+	uint32_t ll_c = 0;
+	uint32_t ll_ten_percent = (uint)tommy_list_count(&ll_cw_cache)*0.1; // 10 percent of cache
+
+	if(!force)
+		sort_list(&ll_cw_cache, time_sort);
+
+	i = get_first_node_list(&ll_cw_cache);
+	while(i)
+	{
+		i_next = i->next;
+		
+		cw_cache = get_data_from_node(i);
+
+		if(!cw_cache)
+		{
+			i = i_next;
+			continue;
+		}
+		if(!force)
+		{
+			++ll_c;
+
+			if(ll_c < ll_ten_percent)
+			{
+				remove_elem_list(&ll_cw_cache, &cw_cache->ll_node);
+				remove_elem_hash_table(&ht_cw_cache, &cw_cache->ht_node);
+				NULLFREE(cw_cache);
+			}
+			else{
+				break;
+			}
+		}
+		else
+		{
+			remove_elem_list(&ll_cw_cache, &cw_cache->ll_node);
+			remove_elem_hash_table(&ht_cw_cache, &cw_cache->ht_node);
+			NULLFREE(cw_cache);
+		}
+
+		i = i_next;
+	}
+	
+	SAFE_RWLOCK_UNLOCK(&cw_cache_lock);
+}
+
 void cleanup_cache(bool force)
 {
 	ECMHASH *ecmhash;
Index: oscam-cache.h
===================================================================
--- oscam-cache.h	(revision 11581)
+++ oscam-cache.h	(working copy)
@@ -2,6 +2,7 @@
 #define OSCAM_CACHE_H_
 
 void init_cache(void);
+void init_cw_cache(void);
 void free_cache(void);
 void add_cache(ECM_REQUEST *er);
 struct ecm_request_t *check_cache(ECM_REQUEST *er, struct s_client *cl);
@@ -10,5 +11,6 @@
 uint32_t cache_size(void);
 uint8_t get_odd_even(ECM_REQUEST *er);
 uint8_t check_is_pushed(void *cw, struct s_client *cl);
-
+void cw_cache_cleanup(bool force);
+int compare_csp_hash(const void *arg, const void *obj);
 #endif
Index: oscam-chk.c
===================================================================
--- oscam-chk.c	(revision 11581)
+++ oscam-chk.c	(working copy)
@@ -154,6 +154,51 @@
 	return (rc == 7);
 }
 
+int32_t chk_srvid_disablecrccws_only_for_exception(ECM_REQUEST *er)
+{
+	int32_t nr;
+	SIDTAB *sidtab;
+
+	for(nr = 0, sidtab = cfg.sidtab; sidtab; sidtab = sidtab->next, nr++)
+	{
+		if(sidtab->disablecrccws_only_for_exception && (sidtab->num_caid | sidtab->num_provid | sidtab->num_srvid) && chk_srvid_match(er, sidtab))
+		{
+			return(1);
+		}
+	}
+	return(0);
+}
+
+int32_t chk_srvid_no_wait_time(ECM_REQUEST *er)
+{
+	int32_t nr;
+	SIDTAB *sidtab;
+
+	for(nr = 0, sidtab = cfg.sidtab; sidtab; sidtab = sidtab->next, nr++)
+	{
+		if(sidtab->no_wait_time && (sidtab->num_caid | sidtab->num_provid | sidtab->num_srvid) && chk_srvid_match(er, sidtab))
+		{
+			return(1);
+		}
+	}
+	return(0);
+}
+
+int32_t chk_srvid_localgenerated_only_exception(ECM_REQUEST *er)
+{
+	int32_t nr;
+	SIDTAB *sidtab;
+
+	for(nr = 0, sidtab = cfg.sidtab; sidtab; sidtab = sidtab->next, nr++)
+	{
+		if(sidtab->lg_only_exception && (sidtab->num_caid | sidtab->num_provid | sidtab->num_srvid) && chk_srvid_match(er, sidtab))
+		{
+			return(1);
+		}
+	}
+	return(0);
+}
+
 int32_t chk_srvid(struct s_client *cl, ECM_REQUEST *er)
 {
 	int32_t nr, rc = 0;
@@ -1193,3 +1238,15 @@
 
 	return is_fakecw;
 }
+
+bool chk_nopushafter(uint16_t caid, CAIDVALUETAB *cv, int32_t ecm_time)
+{
+	uint16_t npa_time = caidvaluetab_get_value(cv, caid, 0);
+	if(npa_time && (ecm_time > npa_time))
+	{
+		cs_log_dbg(D_CACHEEX, "REJECTED push: nopushafter %u < ecm_time %i", npa_time, ecm_time);
+		return 0;
+	}
+	else
+		return 1;
+}
Index: oscam-chk.h
===================================================================
--- oscam-chk.h	(revision 11581)
+++ oscam-chk.h	(working copy)
@@ -39,5 +39,9 @@
 bool check_client(struct s_client *cl);
 uint16_t caidvaluetab_get_value(CAIDVALUETAB *cv, uint16_t caid, uint16_t default_value);
 int32_t chk_is_fakecw(uint8_t *cw);
+int32_t chk_srvid_disablecrccws_only_for_exception(ECM_REQUEST *er);
+int32_t chk_srvid_no_wait_time(ECM_REQUEST *er);
+int32_t chk_srvid_localgenerated_only_exception(ECM_REQUEST *er);
+bool chk_nopushafter(uint16_t caid, CAIDVALUETAB *cv, int32_t ecm_time);
 
 #endif
Index: oscam-client.c
===================================================================
--- oscam-client.c	(revision 11581)
+++ oscam-client.c	(working copy)
@@ -601,6 +601,9 @@
 			if(account && !account->disabled && cl->pcrc == crc32(0L, MD5((uint8_t *)ESTR(account->pwd), strlen(ESTR(account->pwd)), md5tmp), MD5_DIGEST_LENGTH))
 			{
 				cl->account = account;
+#ifdef CS_CACHEEX
+				cl->cacheex_aio_checked = 0;
+#endif
 				if(cl->typ == 'c')
 				{
 					cl->grp = account->grp;
Index: oscam-config-account.c
===================================================================
--- oscam-config-account.c	(revision 11581)
+++ oscam-config-account.c	(working copy)
@@ -469,9 +469,17 @@
 	DEF_OPT_UINT8("cacheex_allow_request"      , OFS(cacheex.allow_request),   0),
 	DEF_OPT_UINT8("no_wait_time"               , OFS(no_wait_time),            0),
 	DEF_OPT_UINT8("cacheex_allow_filter"       , OFS(cacheex.allow_filter),    1),
+	DEF_OPT_UINT8("cacheex_allow_maxhop"       , OFS(cacheex.allow_maxhop),    0),
 	DEF_OPT_UINT8("cacheex_block_fakecws"      , OFS(cacheex.block_fakecws),   0),
 	DEF_OPT_UINT8("disablecrccacheex"          , OFS(disablecrccacheex),       0),
 	DEF_OPT_FUNC_X("disablecrccacheex_only_for", OFS(disablecrccacheex_only_for), ftab_fn, FTAB_ACCOUNT | FTAB_IGNCRCCEX4USERONLYFOR),
+	DEF_OPT_UINT8("cacheex_cw_check_for_push"  , OFS(cacheex.cw_check_for_push), 0),
+	DEF_OPT_UINT8("cacheex_localgenerated_only", OFS(cacheex.localgenerated_only), 0),
+	DEF_OPT_FUNC("cacheex_localgenerated_only_caid", OFS(cacheex.localgenerated_only_caidtab), check_caidtab_fn),
+	DEF_OPT_UINT8("cacheex_lg_only_in_aio_only", OFS(cacheex.lg_only_in_aio_only), 0),
+	DEF_OPT_UINT8("cacheex_localgenerated_only_in", OFS(cacheex.localgenerated_only_in), 0),
+	DEF_OPT_FUNC("cacheex_localgenerated_only_in_caid", OFS(cacheex.localgenerated_only_in_caidtab), check_caidtab_fn),
+	DEF_OPT_FUNC("cacheex_nopushafter"         , OFS(cacheex.cacheex_nopushafter_tab), caidvaluetab_fn),
 #endif
 #ifdef MODULE_CCCAM
 	DEF_OPT_INT32("cccmaxhops"                 , OFS(cccmaxhops),              DEFAULT_CC_MAXHOPS),
@@ -601,6 +609,7 @@
 		config_list_gc_values(account_opts, ptr);
 		ftab_clear(&ptr->ftab);
 		ftab_clear(&ptr->fchid);
+		ftab_clear(&ptr->disablecrccacheex_only_for);
 		tuntab_clear(&ptr->ttab);
 		caidtab_clear(&ptr->ctab);
 		NULLFREE(ptr->cltab.aclass);
@@ -607,6 +616,9 @@
 		NULLFREE(ptr->cltab.bclass);
 #ifdef CS_CACHEEX
 		cecspvaluetab_clear(&ptr->cacheex.filter_caidtab);
+		caidtab_clear(&ptr->cacheex.localgenerated_only_caidtab);
+		caidtab_clear(&ptr->cacheex.localgenerated_only_in_caidtab);
+		caidvaluetab_clear(&ptr->cacheex.cacheex_nopushafter_tab);
 #endif
 #ifdef WITH_LB
 		caidvaluetab_clear(&ptr->lb_nbest_readers_tab);
Index: oscam-config-global.c
===================================================================
--- oscam-config-global.c	(revision 11581)
+++ oscam-config-global.c	(working copy)
@@ -632,8 +632,9 @@
 static bool cache_should_save_fn(void *UNUSED(var))
 {
 	return cfg.delay > 0 || cfg.max_cache_time != 15
+			|| cfg.cw_cache_size > 0 || cfg.cw_cache_memory > 0 
 #ifdef CS_CACHEEX
-			|| cfg.cacheex_wait_timetab.cevnum || cfg.cacheex_enable_stats > 0 || cfg.csp_port || cfg.csp.filter_caidtab.cevnum || cfg.csp.allow_request == 0 || cfg.csp.allow_reforward > 0
+			|| cfg.cacheex_lg_only_in_aio_only || cfg.cacheex_push_lg_groups || cfg.cacheex_filter_caidtab_aio.cevnum || cfg.cacheex_filter_caidtab.cevnum || cfg.cacheex_localgenerated_only_caidtab.ctnum || cfg.cacheex_localgenerated_only_in_caidtab.ctnum || cfg.cacheex_localgenerated_only_in|| cfg.cacheex_localgenerated_only || cfg.cacheex_dropdiffs || cfg.cw_cache_settings.cwchecknum || cfg.cacheex_wait_timetab.cevnum || cfg.cacheex_enable_stats > 0 || cfg.csp_port || cfg.csp.filter_caidtab.cevnum || cfg.csp.allow_request == 0 || cfg.csp.allow_reforward > 0
 #endif
 #ifdef CW_CYCLE_CHECK
 			|| cfg.cwcycle_check_enable || cfg.cwcycle_check_caidtab.ctnum || cfg.maxcyclelist != 500 || cfg.keepcycletime || cfg.onbadcycle || cfg.cwcycle_dropold || cfg.cwcycle_sensitive || cfg.cwcycle_allowbadfromffb || cfg.cwcycle_usecwcfromce
@@ -648,10 +649,25 @@
 	DEF_OPT_UINT32("delay"                , OFS(delay)                  , CS_DELAY),
 	DEF_OPT_INT32("max_time"              , OFS(max_cache_time)         , DEFAULT_MAX_CACHE_TIME),
 #ifdef CS_CACHEEX
+	DEF_OPT_UINT32("cw_cache_size"        , OFS(cw_cache_size)          , 0),
+	DEF_OPT_UINT32("cw_cache_memory"      , OFS(cw_cache_memory)        , 0),
+	DEF_OPT_FUNC("cw_cache_settings"      , OFS(cw_cache_settings)    	, cacheex_cwcheck_tab_fn),
+	DEF_OPT_UINT32("ecm_cache_size"       , OFS(ecm_cache_size)         , 0),
+	DEF_OPT_UINT32("ecm_cache_memory"     , OFS(ecm_cache_memory)       , 0),
+	DEF_OPT_INT32("ecm_cache_droptime"    , OFS(ecm_cache_droptime)     , 0),
 	DEF_OPT_INT32("max_hit_time"          , OFS(max_hitcache_time)      , DEFAULT_MAX_HITCACHE_TIME),
 	DEF_OPT_FUNC("wait_time"              , OFS(cacheex_wait_timetab)   , cacheex_valuetab_fn),
 	DEF_OPT_FUNC("cacheex_mode1_delay"    , OFS(cacheex_mode1_delay_tab), caidvaluetab_fn),
 	DEF_OPT_UINT8("cacheexenablestats"    , OFS(cacheex_enable_stats)   , 0),
+	DEF_OPT_UINT8("cacheex_dropdiffs"     , OFS(cacheex_dropdiffs)      , 0),
+	DEF_OPT_FUNC("cacheex_push_lg_groups" , OFS(cacheex_push_lg_groups)	, group_fn),
+	DEF_OPT_UINT8("cacheex_localgenerated_only", OFS(cacheex_localgenerated_only), 0),
+	DEF_OPT_FUNC("cacheex_localgenerated_only_caid", OFS(cacheex_localgenerated_only_caidtab), check_caidtab_fn),
+	DEF_OPT_UINT8("cacheex_lg_only_in_aio_only", OFS(cacheex_lg_only_in_aio_only), 0),
+	DEF_OPT_UINT8("cacheex_localgenerated_only_in", OFS(cacheex_localgenerated_only_in), 0),
+	DEF_OPT_FUNC("cacheex_localgenerated_only_in_caid", OFS(cacheex_localgenerated_only_in_caidtab), check_caidtab_fn),
+	DEF_OPT_FUNC("cacheex_ecm_filter"     , OFS(cacheex_filter_caidtab) , cacheex_hitvaluetab_fn),
+	DEF_OPT_FUNC("cacheex_ecm_filter_aio" , OFS(cacheex_filter_caidtab_aio) , cacheex_hitvaluetab_fn),
 	DEF_OPT_INT32("csp_port"              , OFS(csp_port)               , 0),
 	DEF_OPT_FUNC("csp_serverip"           , OFS(csp_srvip)              , serverip_fn),
 	DEF_OPT_FUNC("csp_ecm_filter"         , OFS(csp.filter_caidtab)     , cacheex_hitvaluetab_fn),
@@ -660,6 +676,9 @@
 	DEF_OPT_FUNC("cacheex_cw_check"       , OFS(cacheex_cwcheck_tab)    , cacheex_cwcheck_tab_fn),
 	DEF_OPT_UINT8("wait_until_ctimeout"   , OFS(wait_until_ctimeout)    , 0),
 	DEF_OPT_UINT8("csp_block_fakecws"     , OFS(csp.block_fakecws)      , 0),
+	DEF_OPT_FUNC("cacheex_nopushafter"    , OFS(cacheex_nopushafter_tab), caidvaluetab_fn),
+	DEF_OPT_UINT8("waittime_block_start"  , OFS(waittime_block_start)   , 0),
+	DEF_OPT_INT32("waittime_block_time"   , OFS(waittime_block_time)    , 0),
 #endif
 #ifdef CW_CYCLE_CHECK
 	DEF_OPT_INT8("cwcycle_check_enable"   , OFS(cwcycle_check_enable)   , 0),
@@ -1393,7 +1412,13 @@
 	caidtab_clear(&cfg.lb_noproviderforcaid);
 #endif
 #ifdef CS_CACHEEX
+	cwcheckvaluetab_clear(&cfg.cw_cache_settings);
 	caidvaluetab_clear(&cfg.cacheex_mode1_delay_tab);
+	caidvaluetab_clear(&cfg.cacheex_nopushafter_tab);
+	caidtab_clear(&cfg.cacheex_localgenerated_only_caidtab);
+	caidtab_clear(&cfg.cacheex_localgenerated_only_in_caidtab);
+	cecspvaluetab_clear(&cfg.cacheex_filter_caidtab);
+	cecspvaluetab_clear(&cfg.cacheex_filter_caidtab_aio);
 	cecspvaluetab_clear(&cfg.cacheex_wait_timetab);
 #endif
 #ifdef CW_CYCLE_CHECK
Index: oscam-config-reader.c
===================================================================
--- oscam-config-reader.c	(revision 11581)
+++ oscam-config-reader.c	(working copy)
@@ -1135,7 +1135,15 @@
 	DEF_OPT_UINT8("cacheex_allow_request"         , OFS(cacheex.allow_request),           0),
 	DEF_OPT_UINT8("cacheex_drop_csp"              , OFS(cacheex.drop_csp),                0),
 	DEF_OPT_UINT8("cacheex_allow_filter"          , OFS(cacheex.allow_filter),            1),
+	DEF_OPT_UINT8("cacheex_allow_maxhop"          , OFS(cacheex.allow_maxhop),            0),
 	DEF_OPT_UINT8("cacheex_block_fakecws"         , OFS(cacheex.block_fakecws),           0),
+	DEF_OPT_UINT8("cacheex_cw_check_for_push"     , OFS(cacheex.cw_check_for_push),       0),
+	DEF_OPT_UINT8("cacheex_localgenerated_only"   , OFS(cacheex.localgenerated_only),     0),
+	DEF_OPT_FUNC("cacheex_localgenerated_only_caid", OFS(cacheex.localgenerated_only_caidtab), check_caidtab_fn),
+	DEF_OPT_UINT8("cacheex_lg_only_in_aio_only"	  , OFS(cacheex.lg_only_in_aio_only),     0),
+	DEF_OPT_UINT8("cacheex_localgenerated_only_in", OFS(cacheex.localgenerated_only_in),  0),
+	DEF_OPT_FUNC("cacheex_localgenerated_only_in_caid", OFS(cacheex.localgenerated_only_in_caidtab), check_caidtab_fn),
+	DEF_OPT_FUNC("cacheex_nopushafter"            , OFS(cacheex.cacheex_nopushafter_tab), caidvaluetab_fn),
 #endif
 	DEF_OPT_FUNC("caid"                           , OFS(ctab),                            reader_caid_fn),
 	DEF_OPT_FUNC("atr"                            , 0,                                    atr_fn),
@@ -1437,6 +1445,7 @@
 	ftab_clear(&rdr->localcards);
 	ftab_clear(&rdr->fchid);
 	ftab_clear(&rdr->ftab);
+	ftab_clear(&rdr->disablecrccws_only_for);
 
     NULLFREE(rdr->cltab.aclass);
  	NULLFREE(rdr->cltab.bclass);
@@ -1444,6 +1453,9 @@
 	caidtab_clear(&rdr->ctab);
 #ifdef CS_CACHEEX
 	cecspvaluetab_clear(&rdr->cacheex.filter_caidtab);
+	caidtab_clear(&rdr->cacheex.localgenerated_only_caidtab);
+	caidtab_clear(&rdr->cacheex.localgenerated_only_in_caidtab);
+	caidvaluetab_clear(&rdr->cacheex.cacheex_nopushafter_tab);
 #endif
 	lb_destroy_stats(rdr);
 
Index: oscam-config.c
===================================================================
--- oscam-config.c	(revision 11581)
+++ oscam-config.c	(working copy)
@@ -54,6 +54,12 @@
 			ptr++;
 		}
 		fprintf(f, "[%s]\n", sidtab->label);
+		fprintf_conf(f, "disablecrccws_only_for_exception", "%u", sidtab->disablecrccws_only_for_exception); // it should not have \n at the end
+		fputc((int)'\n', f);
+		fprintf_conf(f, "no_wait_time", "%u", sidtab->no_wait_time); // it should not have \n at the end
+		fputc((int)'\n', f);
+		fprintf_conf(f, "lg_only_exception", "%u", sidtab->lg_only_exception); // it should not have \n at the end
+		fputc((int)'\n', f);
 		fprintf_conf(f, "caid", "%s", ""); // it should not have \n at the end
 		for(i = 0; i < sidtab->num_caid; i++)
 		{
@@ -97,9 +103,32 @@
 	uint16_t *slist = (uint16_t *) 0;
 	uint32_t *llist = (uint32_t *) 0;
 	uint32_t caid;
+	uint8_t disablecrccws_only_for_exception = 0;
+	uint8_t no_wait_time = 0;
+	uint8_t lg_only_exception = 0;
 	char buf[strlen(value) + 1];
 	cs_strncpy(buf, value, sizeof(buf));
+
+	if(what == 5) // lg_only_exception
+	{	
+		sidtab->lg_only_exception = a2i(buf, sizeof(lg_only_exception));
+		return;
+	}
+
+	if(what == 4) // no_wait_time
+	{	
+		sidtab->no_wait_time = a2i(buf, sizeof(no_wait_time));
+		return;
+	}
+
+	if(what == 3) // disablecrccws_only_for_exception
+	{	
+		sidtab->disablecrccws_only_for_exception = a2i(buf, sizeof(disablecrccws_only_for_exception));
+		return;
+	}
+
 	b = (what == 1) ? sizeof(uint32_t) : sizeof(uint16_t);
+
 	for(i = 0, ptr = strtok_r(value, ",", &saveptr1); ptr; ptr = strtok_r(NULL, ",", &saveptr1))
 	{
 		caid = a2i(ptr, b);
@@ -166,6 +195,21 @@
 		chk_entry4sidtab(value, sidtab, 2);
 		return;
 	}
+	if(!strcmp(token, "disablecrccws_only_for_exception"))
+	{
+		chk_entry4sidtab(value, sidtab, 3);
+		return;
+	}
+	if(!strcmp(token, "no_wait_time"))
+	{
+		chk_entry4sidtab(value, sidtab, 4);
+		return;
+	}
+	if(!strcmp(token, "lg_only_exception"))
+	{
+		chk_entry4sidtab(value, sidtab, 5);
+		return;
+	}
 	if(token[0] != '#')
 		{ fprintf(stderr, "Warning: keyword '%s' in sidtab section not recognized\n", token); }
 }
@@ -193,6 +237,9 @@
 		char buf[1024];
 		char *saveptr = buf;
 		cs_log("label=%s", sidtab->label);
+		cs_log("disablecrccws_only_for_exception=%u", sidtab->disablecrccws_only_for_exception);
+		cs_log("no_wait_time=%u", sidtab->no_wait_time);
+		cs_log("lg_only_exception=%u", sidtab->lg_only_exception);
 		snprintf(buf, sizeof(buf), "caid(%d)=", sidtab->num_caid);
 		for(i = 0; i < sidtab->num_caid; i++)
 			{ snprintf(buf + strlen(buf), 1024 - (buf - saveptr), "%04X ", sidtab->caid[i]); }
